# -*- coding: utf-8 -*-
# Generated by Django 1.11.6 on 2018-07-07 16:18
from __future__ import unicode_literals

import ckeditor.fields
import datetime
from django.db import migrations, models
import django.db.models.deletion
from django.utils.timezone import utc
import uuid


def create_recommendation_setting(apps, schema_editor):
    from ..models import RecommendationEmailsSettings
    RecommendationEmailsSettings.get_instance()


def remove_recommendation_setting(apps, schema_editor):
    from ..models import RecommendationEmailsSettings
    RecommendationEmailsSettings.get_instance().delete()


class Migration(migrations.Migration):

    replaces = [('recommendation_emails', '0001_initial'), ('recommendation_emails', '0002_auto_20180707_1214'), ('recommendation_emails', '0003_auto_20180707_1222'), ('recommendation_emails', '0002_recommendationemailssettings_subject'), ('recommendation_emails', '0004_merge_20180707_1650'), ('recommendation_emails', '0005_recommendationemails_uuid'), ('recommendation_emails', '0006_auto_20180707_1803'), ('recommendation_emails', '0007_auto_20180707_1901'), ('recommendation_emails', '0008_recommendationemails_sent')]

    initial = True

    dependencies = [
        ('marketing', '0024_auto_20180609_1253'),
        ('news', '0021_category_mail_cta'),
        ('order', '0052_auto_20180401_1653'),
    ]

    operations = [
        migrations.CreateModel(
            name='RecommendationEmails',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('send_time', models.DateTimeField(verbose_name='Дата и время отправки письма')),
                ('will_send', models.BooleanField(default=True, verbose_name='Будет отправлено')),
                ('sended', models.BooleanField(default=False, verbose_name='Отправлено')),
                ('order', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='order.Order', verbose_name='Заказ')),
            ],
            options={
                'verbose_name_plural': 'Рекомендательные письма',
                'verbose_name': 'Рекомендательное письмо',
            },
        ),
        migrations.CreateModel(
            name='RecommendationEmailsSettings',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('greeting', models.CharField(max_length=255, verbose_name='Шаблон приветсвия')),
                ('text', ckeditor.fields.RichTextField(blank=True, help_text='HTML template', null=True, verbose_name='Текст письма')),
                ('article_one', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='article1', to='news.Article', verbose_name='Первая статья')),
                ('article_two', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='article2', to='news.Article', verbose_name='Вторая статья')),
                ('slide', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='marketing.SliderCTA', verbose_name='Слайд')),
            ],
            options={
                'verbose_name_plural': 'настройки рекомендательных писем',
                'verbose_name': 'настройки рекомендательных писем',
            },
        ),
        migrations.AlterField(
            model_name='recommendationemailssettings',
            name='article_one',
            field=models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, related_name='article1', to='news.Article', verbose_name='Первая статья'),
        ),
        migrations.AlterField(
            model_name='recommendationemailssettings',
            name='article_two',
            field=models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, related_name='article2', to='news.Article', verbose_name='Вторая статья'),
        ),
        migrations.AlterField(
            model_name='recommendationemailssettings',
            name='slide',
            field=models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, to='marketing.SliderCTA', verbose_name='Слайд'),
        ),
        migrations.AddField(
            model_name='recommendationemailssettings',
            name='subject',
            field=models.CharField(default='Тема письма', max_length=255, verbose_name='Тема письма'),
            preserve_default=False,
        ),
        migrations.AddField(
            model_name='recommendationemails',
            name='uuid',
            field=models.UUIDField(default=uuid.uuid4, editable=False),
        ),
        migrations.RemoveField(
            model_name='recommendationemails',
            name='send_time',
        ),
        migrations.AddField(
            model_name='recommendationemails',
            name='send_date',
            field=models.DateField(default=datetime.datetime(2018, 7, 7, 16, 18, 5, 119455, tzinfo=utc), verbose_name='Дата планируемой отправки письма'),
            preserve_default=False,
        ),
        migrations.AddField(
            model_name='recommendationemails',
            name='sent_datetime',
            field=models.DateTimeField(blank=True, null=True, verbose_name='Дата и время фактической отправки'),
        ),
        migrations.RemoveField(
            model_name='recommendationemails',
            name='sended',
        ),
        migrations.AddField(
            model_name='recommendationemails',
            name='sent',
            field=models.BooleanField(default=False, verbose_name='Отправлено?'),
        ),
        migrations.AddField(
            model_name='recommendationemails',
            name='rendered_html',
            field=models.TextField(blank=True, null=True, verbose_name='HTML'),
        ),
        migrations.AddField(
            model_name='recommendationemailssettings',
            name='date_delta',
            field=models.PositiveSmallIntegerField(default=6, verbose_name='Дней до отправки письма'),
        ),
        migrations.AddField(
            model_name='recommendationemailssettings',
            name='main_image',
            field=models.ImageField(null=True, upload_to='emails_images/', verbose_name='Основное изображение'),
        ),
        migrations.RunPython(
            code=create_recommendation_setting,
            reverse_code=remove_recommendation_setting,
        ),
    ]
